## libtoxcore 0.2.19

=== CMakeLists.txt ===
################################################################################
#
# The main toxcore CMake build file.
#
# This file when processed with cmake produces:
# - A number of small libraries (.a/.so/...) containing independent components
#   of toxcore. E.g. the DHT has its own library, and the system/network
#   abstractions are in their own library as well. These libraries are not
#   installed on `make install`. The toxav, and toxencryptsave libraries are
#   also not installed.
# - A number of small programs, statically linked if possible.
# - One big library containing all of the toxcore, toxav, and toxencryptsave
#   code.
#
################################################################################

cmake_minimum_required(VERSION 3.16)
cmake_policy(VERSION 3.16)
project(toxcore)

list(APPEND CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)

option(FLAT_OUTPUT_STRUCTURE "Whether to produce output artifacts in ${CMAKE_BINARY_DIR}/{bin,lib}" OFF)
if(FLAT_OUTPUT_STRUCTURE)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

set_source_files_properties(
  toxcore/mono_time.c
  toxcore/network.c
  toxcore/tox.c
  toxcore/util.c
  PROPERTIES SKIP_UNITY_BUILD_INCLUSION TRUE)

################################################################################
#
# :: Version management
#
################################################################################

# This version is for the entire project. All libraries (core, av, ...) move in
# versions in a synchronised way.
set(PROJECT_VERSION_MAJOR "0")
set(PROJECT_VERSION_MINOR "2")
set(PROJECT_VERSION_PATCH "19")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

# set .so library version / following libtool scheme
# https://www.gnu.org/software/libtool/manual/libtool.html#Updating-version-info
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_CURRENT REGEX "^CURRENT=[0-9]+$")
string(SUBSTRING "${SOVERSION_CURRENT}" 8 -1 SOVERSION_CURRENT)
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_REVISION REGEX "^REVISION=[0-9]+$")
string(SUBSTRING "${SOVERSION_REVISION}" 9 -1 SOVERSION_REVISION)
file(STRINGS ${toxcore_SOURCE_DIR}/so.version SOVERSION_AGE REGEX "^AGE=[0-9]+$")
string(SUBSTRING "${SOVERSION_AGE}" 4 -1 SOVERSION_AGE)
# account for some libtool magic, see other/version-sync script for details
math(EXPR SOVERSION_MAJOR ${SOVERSION_CURRENT}-${SOVERSION_AGE})
set(SOVERSION "${SOVERSION_MAJOR}.${SOVERSION_AGE}.${SOVERSION_REVISION}")
message("SOVERSION: ${SOVERSION}")

################################################################################
#
# :: Dependencies and configuration
#
################################################################################

include(CTest)
include(ModulePackage)
include(StrictAbi)
include(GNUInstallDirs)

if(APPLE)
  include(MacRpath)
endif()

enable_testing()
find_package(GTest)

set(CMAKE_MACOSX_RPATH ON)

# Set standard version for compiler.
if(MSVC AND MSVC_TOOLSET_VERSION LESS 143)
  # https://developercommunity.visualstudio.com/t/older-winsdk-headers-are-incompatible-with-zcprepr/1593479
  set(CMAKE_C_STANDARD 99)
else()
  set(CMAKE_C_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_EXTENSIONS OFF)

message(STATUS "Supported C compiler features = ${CMAKE_C_COMPILE_FEATURES}")
message(STATUS "Supported C++ compiler features = ${CMAKE_CXX_COMPILE_FEATURES}")

# Enable some warnings if we know the compiler.
if(MSVC)
  add_compile_options(/W4 /analyze)
  add_compile_options(/wd4100)  # unreferenced formal parameter
  add_compile_options(/wd4267)  # narrowing conversion
  add_compile_options(/wd4244)  # narrowing conversion
  add_compile_options(/wd4127)  # conditional expression is constant
  add_compile_options(/wd4995)  # #pragma deprecated
  add_compile_options(/wd4018)  # signed/unsigned compare
  add_compile_options(/wd4310)  # cast truncates constant value
  add_compile_options(/wd4389)  # signed/unsigned compare
  add_compile_options(/wd4245)  # signed/unsigned assign/return/function call
  add_compile_options(/wd4200)  # nonstandard extension used: zero-sized array in struct/union
  add_compile_options(/wd4702)  # unreachable code
  add_compile_options(/wd6340)  # unsigned int passed to signed parameter
  add_compile_options(/wd6326)  # potential comparison of a constant with another constant

  # TODO(iphydf): Look into these
  add_compile_options(/wd4996)  # use WSAAddressToStringW() instead of WSAAddressToStringA()
  add_compile_options(/wd6255)  # don't use alloca
  add_compile_options(/wd6385)  # reading invalid data
  add_compile_options(/wd6001)  # using uninitialized memory
  add_compile_options(/wd6101)  # returning uninitialized memory
  add_compile_options(/wd6386)  # buffer overrun
  add_compile_options(/wd6011)  # NULL dereference
  add_compile_options(/wd6031)  # sscanf return value ignored
  add_compile_options(/wd6387)  # passing NULL to fwrite
endif()

set(MIN_LOGGER_LEVEL "" CACHE STRING "Logging level to use (TRACE, DEBUG, INFO, WARNING, ERROR)")
if(MIN_LOGGER_LEVEL)
  if(("${MIN_LOGGER_LEVEL}" STREQUAL "TRACE") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "DEBUG") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "INFO") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "WARNING") OR
     ("${MIN_LOGGER_LEVEL}" STREQUAL "ERROR"))
    add_definitions(-DMIN_LOGGER_LEVEL=LOGGER_LEVEL_${MIN_LOGGER_LEVEL})
  else()
    message(FATAL_ERROR "Unknown value provided for MIN_LOGGER_LEVEL: \"${MIN_LOGGER_LEVEL}\", must be one of TRACE, DEBUG, INFO, WARNING or ERROR")
  endif()
endif()

option(EXPERIMENTAL_API "Install experimental header file with unstable API" OFF)

option(USE_IPV6 "Use IPv6 in tests" ON)
if(NOT USE_IPV6)
  add_definitions(-DUSE_IPV6=0)
endif()

option(BUILD_MISC_TESTS "Build additional tests" OFF)
option(BUILD_FUN_UTILS "Build additional just for fun utilities" OFF)

option(UNITTEST "Enable unit tests (disable if you don't have a working gmock or gtest)" ON)

option(AUTOTEST "Enable autotests (mainly for CI)" OFF)
if(AUTOTEST)
  option(NON_HERMETIC_TESTS "Whether to build and run tests that depend on an internet connection" OFF)
  option(PROXY_TEST "Enable proxy test (requires other/proxy/proxy_server.go to be running)" OFF)
endif()

option(BUILD_TOXAV "Whether to build the tox AV library" ON)
option(MUST_BUILD_TOXAV "Fail the build if toxav cannot be built" OFF)

option(DHT_BOOTSTRAP "Enable building of DHT_bootstrap" ON)
option(BOOTSTRAP_DAEMON "Enable building of tox-bootstrapd" ON)
if(BOOTSTRAP_DAEMON AND WIN32)
  message(WARNING "Building tox-bootstrapd for Windows is not supported, disabling")
  set(BOOTSTRAP_DAEMON OFF)
endif()

option(BUILD_FUZZ_TESTS "Build fuzzing harnesses" OFF)

if(MSVC)
  option(MSVC_STATIC_SODIUM "Whether to link libsodium statically for MSVC" OFF)
  if(MSVC_STATIC_SODIUM)
    add_definitions(-DSODIUM_STATIC=1)
  endif()
endif()

include(Dependencies)

if(MUST_BUILD_TOXAV)
  set(NO_TOXAV_ERROR_TYPE SEND_ERROR)
else()
  set(NO_TOXAV_ERROR_TYPE WARNING)
endif()

if(BUILD_TOXAV)
  if(NOT OPUS_FOUND)
    message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library OPUS was not found.")
    set(BUILD_TOXAV OFF)
  endif()
  if(NOT VPX_FOUND)
    message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library VPX was not found.")
    set(BUILD_TOXAV OFF)
  endif()
endif()

# Disable float/double packing in CMP (C MessagePack library).
# We don't transfer floats over the network, so we disable this functionality.
add_definitions(-DCMP_NO_FLOAT=1)

################################################################################
#
# :: Tox Core Library
#
################################################################################

# toxcore_PKGCONFIG_LIBS is what's added to the Libs: line in toxcore.pc. It
# needs to contain all the libraries a program using toxcore should link against
# if it's statically linked. If it's dynamically linked, there is no need to
# explicitly link against all the dependencies, but it doesn't harm much(*)
# either.
#
# (*) It allows client code to use symbols from our dependencies without
#    explicitly linking against them.
set(toxcore_PKGCONFIG_LIBS)
# Requires: in pkg-config file.
set(toxcore_PKGCONFIG_REQUIRES)

set(toxcore_SOURCES
  third_party/cmp/cmp.c
  third_party/cmp/cmp.h
  toxcore/announce.c
  toxcore/announce.h
  toxcore/bin_pack.c
  toxcore/bin_pack.h
  toxcore/bin_unpack.c
  toxcore/bin_unpack.h
  toxcore/ccompat.c
  toxcore/ccompat.h
  toxcore/crypto_core.c
  toxcore/crypto_core.h
  toxcore/crypto_core_pack.c
  toxcore/crypto_core_pack.h
  toxcore/DHT.c
  toxcore/DHT.h
  toxcore/events/conference_connected.c
  toxcore/events/conference_invite.c
  toxcore/events/conference_message.c
  toxcore/events/conference_peer_list_changed.c
  toxcore/events/conference_peer_name.c
  toxcore/events/conference_title.c
  toxcore/events/dht_get_nodes_response.c
  toxcore/events/events_alloc.c
  toxcore/events/events_alloc.h
  toxcore/events/file_chunk_request.c
  toxcore/events/file_recv.c
  toxcore/events/file_recv_chunk.c
  toxcore/events/file_recv_control.c
  toxcore/events/friend_connection_status.c
  toxcore/events/friend_lossless_packet.c
  toxcore/events/friend_lossy_packet.c
  toxcore/events/friend_message.c
  toxcore/events/friend_name.c
  toxcore/events/friend_read_receipt.c
  toxcore/events/friend_request.c
  toxcore/events/friend_status.c
  toxcore/events/friend_status_message.c
  toxcore/events/friend_typing.c
  toxcore/events/self_connection_status.c
  toxcore/events/group_custom_packet.c
  toxcore/events/group_custom_private_packet.c
  toxcore/events/group_invite.c
  toxcore/events/group_join_fail.c
  toxcore/events/group_message.c
  toxcore/events/group_moderation.c
  toxcore/events/group_password.c
  toxcore/events/group_peer_exit.c
  toxcore/events/group_peer_join.c
  toxcore/events/group_peer_limit.c
  toxcore/events/group_peer_name.c
  toxcore/events/group_peer_status.c
  toxcore/events/group_privacy_state.c
  toxcore/events/group_private_message.c
  toxcore/events/group_self_join.c
  toxcore/events/group_topic.c
  toxcore/events/group_topic_lock.c
  toxcore/events/group_voice_state.c
  toxcore/forwarding.c
  toxcore/forwarding.h
  toxcore/friend_connection.c
  toxcore/friend_connection.h
  toxcore/friend_requests.c
  toxcore/friend_requests.h
  toxcore/group.c
  toxcore/group_chats.c
  toxcore/group_chats.h
  toxcore/group_common.h
  toxcore/group_connection.c
  toxcore/group_connection.h
  toxcore/group.h
  toxcore/group_announce.c
  toxcore/group_announce.h
  toxcore/group_moderation.c
  toxcore/group_moderation.h
  toxcore/group_onion_announce.c
  toxcore/group_onion_announce.h
  toxcore/group_pack.c
  toxcore/group_pack.h
  toxcore/LAN_discovery.c
  toxcore/LAN_discovery.h
  toxcore/list.c
  toxcore/list.h
  toxcore/logger.c
  toxcore/logger.h
  toxcore/Messenger.c
  toxcore/Messenger.h
  toxcore/mem.c
  toxcore/mem.h
  toxcore/mono_time.c
  toxcore/mono_time.h
  toxcore/net_crypto.c
  toxcore/net_crypto.h
  toxcore/network.c
  toxcore/network.h
  toxcore/onion_announce.c
  toxcore/onion_announce.h
  toxcore/onion.c
  toxcore/onion_client.c
  toxcore/onion_client.h
  toxcore/onion.h
  toxcore/ping_array.c
  toxcore/ping_array.h
  toxcore/ping.c
  toxcore/ping.h
  toxcore/shared_key_cache.c
  toxcore/shared_key_cache.h
  toxcore/state.c
  toxcore/state.h
  toxcore/TCP_client.c
  toxcore/TCP_client.h
  toxcore/TCP_common.c
  toxcore/TCP_common.h
  toxcore/TCP_connection.c
  toxcore/TCP_connection.h
  toxcore/TCP_server.c
  toxcore/TCP_server.h
  toxcore/timed_auth.c
  toxcore/timed_auth.h
  toxcore/tox_api.c
  toxcore/tox.c
  toxcore/tox_dispatch.c
  toxcore/tox_dispatch.h
  toxcore/tox_event.c
  toxcore/tox_event.h
  toxcore/tox_events.c
  toxcore/tox_events.h
  toxcore/tox.h

=== testing/CMakeLists.txt ===
# Helpful code for tests and other utilities
set(misc_tools_SOURCES
  misc_tools.c
  misc_tools.h)
add_library(misc_tools STATIC ${misc_tools_SOURCES})
if(TARGET toxcore_static)
  target_link_libraries(misc_tools PRIVATE toxcore_static)
else()
  target_link_libraries(misc_tools PRIVATE toxcore_shared)
endif()
if(TARGET unofficial-sodium::sodium)
  target_link_libraries(misc_tools PRIVATE unofficial-sodium::sodium)
else()
  target_link_libraries(misc_tools PRIVATE ${LIBSODIUM_LIBRARIES})
  target_link_directories(misc_tools PUBLIC ${LIBSODIUM_LIBRARY_DIRS})
  target_include_directories(misc_tools SYSTEM PRIVATE ${LIBSODIUM_INCLUDE_DIRS})
  target_compile_options(misc_tools PRIVATE ${LIBSODIUM_CFLAGS_OTHER})
endif()
if(TARGET PThreads4W::PThreads4W)
  target_link_libraries(misc_tools PRIVATE PThreads4W::PThreads4W)
elseif(TARGET Threads::Threads)
  target_link_libraries(misc_tools PRIVATE Threads::Threads)
endif()

################################################################################
#
# :: Test programs
#
################################################################################

if(BUILD_MISC_TESTS)
  add_executable(Messenger_test Messenger_test.c)
  target_link_libraries(Messenger_test PRIVATE misc_tools)
  if(TARGET toxcore_static)
    target_link_libraries(Messenger_test PRIVATE toxcore_static)
  else()
    target_link_libraries(Messenger_test PRIVATE toxcore_shared)
  endif()
  if(TARGET PThreads4W::PThreads4W)
    target_link_libraries(Messenger_test PRIVATE PThreads4W::PThreads4W)
  elseif(TARGET Threads::Threads)
    target_link_libraries(Messenger_test PRIVATE Threads::Threads)
  endif()
endif()

=== other/bootstrap_daemon/CMakeLists.txt ===
# Unity build broken because of _XOPEN_SOURCE macro
set_source_files_properties(
  src/tox-bootstrapd.c
  PROPERTIES SKIP_UNITY_BUILD_INCLUSION TRUE)

add_executable(tox-bootstrapd
  src/command_line_arguments.c
  src/command_line_arguments.h
  src/config.c
  src/config.h
  src/config_defaults.h
  src/global.h
  src/log.c
  src/log.h
  src/log_backend_stdout.c
  src/log_backend_stdout.h
  src/log_backend_syslog.c
  src/log_backend_syslog.h
  src/tox-bootstrapd.c
  ../bootstrap_node_packets.c
  ../bootstrap_node_packets.h)
target_link_libraries(tox-bootstrapd PRIVATE ${LIBCONFIG_LIBRARIES})
target_link_directories(tox-bootstrapd PRIVATE ${LIBCONFIG_LIBRARY_DIRS})
target_include_directories(tox-bootstrapd SYSTEM PRIVATE ${LIBCONFIG_INCLUDE_DIRS})
target_compile_options(tox-bootstrapd PRIVATE ${LIBCONFIG_CFLAGS_OTHER})
if(TARGET toxcore_static)
  target_link_libraries(tox-bootstrapd PRIVATE toxcore_static)
else()
  target_link_libraries(tox-bootstrapd PRIVATE toxcore_shared)
endif()
install(TARGETS tox-bootstrapd RUNTIME DESTINATION bin)
install(FILES bash-completion/completions/tox-bootstrapd DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions")

=== other/fun/CMakeLists.txt ===
function(target_link_toxcore target)
  if(TARGET toxcore_static)
    target_link_libraries(${target} PRIVATE toxcore_static)
  else()
    target_link_libraries(${target} PRIVATE toxcore_shared)
  endif()
endfunction()

function(target_link_sodium target)
  if(TARGET unofficial-sodium::sodium)
    target_link_libraries(${target} PRIVATE unofficial-sodium::sodium)
  else()
    target_link_libraries(${target} PRIVATE ${LIBSODIUM_LIBRARIES})
    target_link_directories(${target} PRIVATE ${LIBSODIUM_LIBRARY_DIRS})
    target_include_directories(${target} SYSTEM PRIVATE ${LIBSODIUM_INCLUDE_DIRS})
    target_compile_options(${target} PRIVATE ${LIBSODIUM_CFLAGS_OTHER})
  endif()
endfunction()

add_executable(save-generator save-generator.c)
target_link_libraries(save-generator PRIVATE misc_tools)
target_link_toxcore(save-generator)

add_executable(strkey strkey.c)
target_link_sodium(strkey)

add_executable(create_bootstrap_keys create_bootstrap_keys.c)
target_link_sodium(create_bootstrap_keys)

add_executable(create_minimal_savedata create_minimal_savedata.c)
target_link_sodium(create_minimal_savedata)

add_executable(create_savedata create_savedata.c)
target_link_sodium(create_savedata)
target_link_toxcore(create_savedata)

add_executable(sign sign.c)
target_link_sodium(sign)

add_executable(cracker_simple cracker_simple.c)
target_link_sodium(cracker_simple)

find_package(OpenMP)
if(OpenMP_C_FOUND)
  add_executable(cracker cracker.c)
  target_link_libraries(cracker PRIVATE OpenMP::OpenMP_C)
  target_link_sodium(cracker)
else()
  add_executable(cracker cracker.c)
  target_link_sodium(cracker)
endif()

=== other/docker/misra/Makefile ===
# See the following PDF for descriptions of each of the rules:
# http://my.ldrasoftware.co.uk/repository/miscellaneous/Misra-c_2012_compliance.pdf

# There should be no unused parameters in functions.
#
# Reason: callbacks often have unused parameters. Marking them explicitly isn't
# very helpful. A better diagnostic should be able to identify functions never
# used as callbacks and warn about unused parameters in those.
SUPPRESSIONS = 2.7
# The character sequences /* and // shall not be used within a comment.
#
# Reason: "//" appears in code examples and "http://" inside comments.
SUPPRESSIONS += 3.1
# Identifiers declared in the same scope and name space shall be distinct.
# Identifier not unique within 31 characters.
#
# Reason: Compilers we use allow longer identifier names.
SUPPRESSIONS += 5.2
# Macro identifiers shall be distinct.
# Identifier matches macro name in 31 chars.
#
# Reason: Compilers we use allow longer identifier names.
SUPPRESSIONS += 5.4
# The lowercase character 'l' shall not be used in a literal suffix.
#
# Reason: False positive. We don't use 'l', but this flags 'ulOutBufLen'.
SUPPRESSIONS += 7.3
# Operands shall not be of an inappropriate essential type.
#
# Reason: This diagnoses (1 << n) and wants us to use (1u << n). That's fair,
# but this diagnostic is impossible to fix for ((1u << n) >> m).
SUPPRESSIONS += 10.1
# Both operands of an operator in which the usual arithmetic conversions are performed shall have the same essential type category.
#
# Reason: This warns about ((unsigned)n == 0) and other constant comparisons.
SUPPRESSIONS += 10.4
# The value of a composite expression shall not be cast to a different essential type category or a wider essential type.
#
# TODO(iphydf): investigate.
SUPPRESSIONS += 10.8
# A conversion should not be performed from pointer to void into pointer to object.
#
# Reason: this is needed for generic callbacks to make any sense.
SUPPRESSIONS += 11.5
# The precedence of operators within expressions should be made explicit.
#
# Reason: this asks us to add a lot of extra parentheses that don't really help
# readability. We expect people to know basic precedence. GCC has a better
# diagnostic requiring parentheses around less common operators.
SUPPRESSIONS += 12.1
# The comma operator should not be used.
#
# Reason: We don't use the comma operator (cimple doesn't even parse it). This is
# all false positives.
SUPPRESSIONS += 12.3
# Evaluation of constant expressions should not lead to unsigned integer wrap-around.
#
# Reason: False positives on UINT64_MAX.
SUPPRESSIONS += 12.4
# A full expression containing an increment (++) or decrement (--) operator should have no other potential side effects other than that caused by the increment or decrement operator.
#
# TODO(iphydf): maybe fix?
SUPPRESSIONS += 13.3
# The controlling expression of an if statement and the controlling expression of an iteration-statement shall have essentially Boolean type.
#
# Reason: We actually follow this rule, but cppcheck's implementation is flawed and has false positives.
SUPPRESSIONS += 14.4
# The goto statement should not be used.
#
# TODO(iphydf): Get rid of goto.
SUPPRESSIONS += 15.1
# A function should have a single point of exit at the end.
#
# Reason: This doesn't make code much clearer. Sometimes this is useful for
# putting all the cleanup code in one spot, but often an early return improves
# readability.
SUPPRESSIONS += 15.5
# All if . . else if constructs shall be terminated with an else statement.
#
# TODO(iphydf): Why is this a good idea?
SUPPRESSIONS += 15.7
# An unconditional break statement shall terminate every switch-clause.
#
# Reason: This conflicts with "break unused after abort()". MISRA doesn't allow
# abort(), but we use it, so this rule must be disabled, too.
SUPPRESSIONS += 16.3
# Every switch statement shall have a default label.
#
# Reason: C compilers have better diagnostics for this (-Wswitch variants).
SUPPRESSIONS += 16.4
# The features of <stdarg.h> shall not be used.
#
# Reason: We use it for logging.
SUPPRESSIONS += 17.1
# Functions shall not call themselves, either directly or indirectly.
#
# Reason: Cimple is better at this diagnostic, recognising indirect recursion
# through callbacks.
SUPPRESSIONS += 17.2
# The value returned by a function having non-void return type shall be used.
#
# TODO(iphydf): Investigate.
SUPPRESSIONS += 17.7
# A function parameter should not be modified.
#
# TODO(iphydf): maybe fix?
SUPPRESSIONS += 17.8
# The +, -, += and -= operators should not be applied to an expression of pointer type.
# Use of pointer arithmetic.
#
# TODO(iphydf): Someday we won't be using pointer arithmetic.
SUPPRESSIONS += 18.4
# Flexible array members shall not be declared.
#
# TODO(iphydf): Fix.
SUPPRESSIONS += 18.7
# Variable-length array types shall not be used.
#
# TODO(iphydf): Fix.
SUPPRESSIONS += 18.8
# The union keyword should not be used.
#
# TODO(iphydf): Maybe we need a good linter to check that unions are used safely.
SUPPRESSIONS += 19.2
# #undef should not be used.
#
# Reason: We believe it should be used when #define is used in block scope.
SUPPRESSIONS += 20.5
# #define and #undef shall not be used on a reserved identifier or reserved macro name.
#
# Reason: Needed for feature test macros like _DEFAULT_SOURCE.
SUPPRESSIONS += 21.1
# The memory allocation and deallocation functions of <stdlib.h> shall not be used.
#
# Reason: We use malloc/free. Making our own allocators doesn't make the code
# safer.
SUPPRESSIONS += 21.3
# The Standard Library input/output routines shall not be used.
#
# Reason: Used in logging.
SUPPRESSIONS += 21.6
# The Standard Library termination functions of <stdlib.h> shall not be used.
# Use of abort, exit, etc.
#
# Reason: Used in LOGGER_FATAL.
SUPPRESSIONS += 21.8
# The Standard Library functions bsearch and qsort of <stdlib.h> shall not be used.
#
# TODO(iphydf): Why not use qsort?
SUPPRESSIONS += 21.9
# The Standard Library time and date routines shall not be used.
#
# TODO(iphydf): Probably stop using time().
SUPPRESSIONS += 21.10

CPPFLAGS := -DCMP_NO_FLOAT=1 -DMIN_LOGGER_LEVEL=LOGGER_LEVEL_TRACE

FIND_FLAGS := -name "*.c"								\
			  -and -not -wholename "*/auto_tests/*"		\
			  -and -not -wholename "*/other/*"			\
			  -and -not -wholename "*/super_donators/*"	\
			  -and -not -wholename "*/third_party/*"
SOURCES := $(shell find /src/workspace/c-toxcore $(FIND_FLAGS))

analyse: $(DUMPS:.dump=.diag)
	cppcheck --error-exitcode=1 -j8 --addon=misra --suppress=doubleFree $(patsubst %,--suppress=misra-c2012-%,$(SUPPRESSIONS)) $(CPPFLAGS) $(SOURCES)

=== other/docker/esp32/bootstrap/CMakeLists.txt ===
idf_component_register(
  SRCS hello_main.cc
  INCLUDE_DIRS "."
  REQUIRES esp_netif lwip)

=== debian/changelog ===
libtoxcore (0.2.19-1build1) plucky; urgency=medium

  * No-change rebuild for libconfig11.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 27 Jan 2025 19:45:09 +0000

libtoxcore (0.2.19-1) unstable; urgency=medium

  * New upstream release
  * Remove flaky autopkgtest (Closes: #1053501)
  * Bump Standards-Version to 4.7.0

 -- Yangfl <mmyangfl@gmail.com>  Sun, 30 Jun 2024 23:52:53 +0800

=== debian/control ===
Source: libtoxcore
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 libconfig-dev,
 libncurses5-dev,
 libopus-dev,
 libsodium-dev,
 libvpx-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Section: libs
Homepage: https://tox.chat
Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/c-toxcore

Package: libtoxcore2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Distributed, secure messenger
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.

Package: libtoxcore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libtoxcore2 (= ${binary:Version}),
 libsodium-dev,
 libopus-dev,
 libvpx-dev,
Description: Distributed, secure messenger - development headers
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.
 .
 This package contains the development headers.

Package: toxcore-utils
Architecture: any
Section: net
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Distributed, secure messenger - DHT bootstrap tools
 Tox provides an encrypted, distributed, and extensible peer-to-peer platform
 that can be used for various forms of communication. Tox is intended to be used
 as a multimedia messenger, but many people have shown that Tox can be used for
 a lot more than just instant messaging.
 .
 This package contains DHT bootstrap tools, including DHT_bootstrap and
 tox-bootstrapd.

=== debian/watch ===
version=4
opts="downloadurlmangle=s%archive/refs/tags/v?(\d[\d.]*)\.tar\.gz%releases/download/v$1/c-toxcore-$1.tar.gz%,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libtoxcore-$1.tar.gz%,pgpsigurlmangle=s%$%.asc%" \
   https://github.com/TokTok/c-toxcore/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libtoxcore 0.2.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "19")
+set(PROJECT_VERSION_PATCH "20")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
@@ -161,7 +161,7 @@
 option(BOOTSTRAP_DAEMON "Enable building of tox-bootstrapd" ON)
 if(BOOTSTRAP_DAEMON AND WIN32)
   message(WARNING "Building tox-bootstrapd for Windows is not supported, disabling")
-  set(BOOTSTRAP_DAEMON OFF)
+  set(BOOTSTRAP_DAEMON OFF CACHE BOOL "" FORCE)
 endif()
 
 option(BUILD_FUZZ_TESTS "Build fuzzing harnesses" OFF)
@@ -177,6 +177,7 @@
 
 if(MUST_BUILD_TOXAV)
   set(NO_TOXAV_ERROR_TYPE SEND_ERROR)
+  set(BUILD_TOXAV ON CACHE BOOL "" FORCE)
 else()
   set(NO_TOXAV_ERROR_TYPE WARNING)
 endif()
@@ -184,11 +185,11 @@
 if(BUILD_TOXAV)
   if(NOT OPUS_FOUND)
     message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library OPUS was not found.")
-    set(BUILD_TOXAV OFF)
+    set(BUILD_TOXAV OFF CACHE BOOL "" FORCE)
   endif()
   if(NOT VPX_FOUND)
     message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library VPX was not found.")
-    set(BUILD_TOXAV OFF)
+    set(BUILD_TOXAV OFF CACHE BOOL "" FORCE)
   endif()
 endif()
 
@@ -338,8 +339,3 @@
   toxcore/tox.c
   toxcore/tox_dispatch.c
   toxcore/tox_dispatch.h
-  toxcore/tox_event.c
-  toxcore/tox_event.h
-  toxcore/tox_events.c
-  toxcore/tox_events.h
-  toxcore/tox.h

=== auto_tests/CMakeLists.txt ===
set(TEST_TIMEOUT_SECONDS "" CACHE STRING "Limit runtime of each test to the number of seconds specified")

add_library(auto_test_support
  auto_test_support.c
  auto_test_support.h)
target_link_libraries(auto_test_support PRIVATE misc_tools)
if(TARGET toxcore_static)
  target_link_libraries(auto_test_support PRIVATE toxcore_static)
else()
  target_link_libraries(auto_test_support PRIVATE toxcore_shared)
endif()
if(TARGET PThreads4W::PThreads4W)
  target_link_libraries(auto_test_support PRIVATE PThreads4W::PThreads4W)
elseif(TARGET Threads::Threads)
  target_link_libraries(auto_test_support PRIVATE Threads::Threads)
endif()

function(auto_test target)
  add_executable(auto_${target}_test ${target}_test.c)
  target_link_libraries(auto_${target}_test PRIVATE misc_tools auto_test_support)
  if(TARGET toxcore_static)
    target_link_libraries(auto_${target}_test PRIVATE toxcore_static)
  else()
    target_link_libraries(auto_${target}_test PRIVATE toxcore_shared)
  endif()
  if(TARGET PThreads4W::PThreads4W)
    target_link_libraries(auto_${target}_test PRIVATE PThreads4W::PThreads4W)
  elseif(TARGET Threads::Threads)
    target_link_libraries(auto_${target}_test PRIVATE Threads::Threads)
  endif()
  add_test(NAME ${target} COMMAND ${CROSSCOMPILING_EMULATOR} auto_${target}_test)
  set_tests_properties(${target} PROPERTIES TIMEOUT "${TEST_TIMEOUT_SECONDS}")
  # add the source dir as environment variable, so the testdata can be found
  set_tests_properties(${target} PROPERTIES ENVIRONMENT "LLVM_PROFILE_FILE=${target}.profraw;srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
endfunction()

auto_test(TCP)
auto_test(announce)
auto_test(conference)
auto_test(conference_double_invite)
auto_test(conference_invite_merge)
auto_test(conference_peer_nick)
auto_test(conference_simple)
auto_test(conference_two)
auto_test(crypto)
#auto_test(dht)  # Doesn't work with UNITY_BUILD.
auto_test(dht_getnodes_api)
auto_test(encryptsave)
auto_test(file_saving)
auto_test(file_streaming)
auto_test(file_transfer)
auto_test(forwarding)
auto_test(friend_connection)
auto_test(friend_request)
auto_test(friend_request_spam)
auto_test(group_general)
auto_test(group_invite)
auto_test(group_message)
auto_test(group_moderation)
auto_test(group_save)
auto_test(group_state)
auto_test(group_sync)
auto_test(group_tcp)
auto_test(group_topic)
auto_test(invalid_tcp_proxy)
auto_test(invalid_udp_proxy)
auto_test(lan_discovery)
auto_test(lossless_packet)
auto_test(lossy_packet)
auto_test(network)
auto_test(onion)
auto_test(overflow_recvq)
auto_test(overflow_sendq)
auto_test(reconnect)
auto_test(save_friend)
auto_test(save_load)
auto_test(send_message)
auto_test(set_name)
auto_test(set_status_message)
auto_test(tox_dispatch)
auto_test(tox_events)
auto_test(tox_many)
auto_test(tox_many_tcp)
auto_test(tox_strncasecmp)
auto_test(typing)
auto_test(version)
auto_test(save_compatibility)

target_include_directories(auto_encryptsave_test SYSTEM PRIVATE ${LIBSODIUM_INCLUDE_DIRS})

if(NON_HERMETIC_TESTS)
  auto_test(bootstrap)
  auto_test(tcp_relay)
endif()

if(BUILD_TOXAV)
  auto_test(conference_av)
  auto_test(toxav_basic)
  auto_test(toxav_many)

  if(MSVC)
    target_link_libraries(auto_toxav_basic_test PRIVATE PkgConfig::VPX)
    target_link_libraries(auto_toxav_many_test PRIVATE PkgConfig::VPX)
  else()
    target_link_libraries(auto_toxav_basic_test PRIVATE ${VPX_LIBRARIES})
    target_link_directories(auto_toxav_basic_test PRIVATE ${VPX_LIBRARY_DIRS})
    target_include_directories(auto_toxav_basic_test SYSTEM PRIVATE ${VPX_INCLUDE_DIRS})
    target_compile_options(auto_toxav_basic_test PRIVATE ${VPX_CFLAGS_OTHER})

    target_link_libraries(auto_toxav_many_test PRIVATE ${VPX_LIBRARIES})
    target_link_directories(auto_toxav_many_test PRIVATE ${VPX_LIBRARY_DIRS})
    target_include_directories(auto_toxav_many_test SYSTEM PRIVATE ${VPX_INCLUDE_DIRS})
    target_compile_options(auto_toxav_many_test PRIVATE ${VPX_CFLAGS_OTHER})
  endif()
endif()

if(PROXY_TEST)
  auto_test(proxy)
endif()

=== testing/fuzzing/CMakeLists.txt ===
# Override network and random functions
add_library(fuzz_support func_conversion.hh fuzz_support.cc fuzz_support.hh)

set(LIBFUZZER_LINKER_FLAGS)
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(LIBFUZZER_LINKER_FLAGS "-fsanitize=fuzzer")
else()
  message(SEND_ERROR "Compiler must be Clang to build fuzz targets")
endif()

function(fuzz_test target source_dir)
  set(CORPUS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/toktok-fuzzer/corpus/${target}_fuzz_test)
  file(GLOB CORPUS "${CORPUS_DIR}/*")
  add_executable(${target}_fuzz_test ${source_dir}/${target}_fuzz_test.cc)
  target_link_libraries(${target}_fuzz_test PRIVATE fuzz_support test_util toxcore_fuzz ${LIBFUZZER_LINKER_FLAGS})
  if(CORPUS)
    add_test(NAME ${target}_fuzz COMMAND ${CROSSCOMPILING_EMULATOR} ${target}_fuzz_test -max_total_time=10 ${CORPUS})
    set_property(TEST ${target}_fuzz PROPERTY ENVIRONMENT "LLVM_PROFILE_FILE=${target}.profraw;srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
  endif()
endfunction()

fuzz_test(bootstrap        .)  # Fuzzes the bootstrap process
fuzz_test(toxsave          .)  # Fuzzes the bootstrap process

fuzz_test(DHT              ../../toxcore)
fuzz_test(forwarding       ../../toxcore)
fuzz_test(group_announce   ../../toxcore)
fuzz_test(group_moderation ../../toxcore)
fuzz_test(tox_events       ../../toxcore)

=== third_party/cmp/CMakeLists.txt ===
# Edit following two lines to set component requirements (see docs)
set(COMPONENT_SRCS "cmp.c" )
set(COMPONENT_ADD_INCLUDEDIRS ".")
register_component()

=== third_party/cmp/Makefile ===
CC ?= gcc
CLANG ?= clang

EXTRA_CFLAGS ?= -Werror -Wall -Wextra -funsigned-char -fwrapv -Wconversion \
				-Wno-sign-conversion -Wmissing-format-attribute \
				-Wpointer-arith -Wformat-nonliteral -Winit-self \
				-Wwrite-strings -Wshadow -Wenum-compare -Wempty-body \
				-Wparentheses -Wcast-align -Wstrict-aliasing --pedantic-errors
CMPCFLAGS ?= -std=c89 -Wno-c99-extensions
TESTCFLAGS ?= -std=c99 -Wno-error=deprecated-declarations \
			  -Wno-deprecated-declarations -O0
NOFPUTESTCFLAGS ?= $(TESTCFLAGS) -DCMP_NO_FLOAT

ADDRCFLAGS ?= -fsanitize=address
MEMCFLAGS ?= -fsanitize=memory -fno-omit-frame-pointer \
			 -fno-optimize-sibling-calls
UBCFLAGS ?= -fsanitize=undefined,nullability,local-bounds,float-divide-by-zero,integer

.PHONY: all clean test coverage

all: cmpunittest example1 example2

profile: cmpprof
	@env LD_PRELOAD=/usr/lib/libprofiler.so CPUPROFILE=cmp.prof \
		CPUPROFILE_FREQUENCY=1000 ./cmpprof
	@pprof --web ./cmpprof cmp.prof

test: addrtest memtest nofloattest ubtest unittest

testprogs: cmpaddrtest cmpmemtest cmpnofloattest cmpubtest cmpunittest

addrtest: cmpaddrtest
	@./cmpaddrtest

memtest: cmpmemtest
	@./cmpmemtest

nofloattest: cmpnofloattest
	@./cmpnofloattest
	@rm -f *.gcno *.gcda *.info

ubtest: cmpubtest
	@./cmpubtest

unittest: cmpunittest
	@./cmpunittest

cmp.o: cmp.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(CMPCFLAGS) \
		-fprofile-arcs -ftest-coverage -g -I. -c cmp.c

cmpprof: cmp.o
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(TESTCFLAGS) $(LDFLAGS) \
		-fprofile-arcs -I. \
		-o cmpprof cmp.o test/profile.c test/tests.c test/buf.c test/utils.c \
		-lcmocka -lprofiler

cmpunittest: cmp.o
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(TESTCFLAGS) $(LDFLAGS) \
		-fprofile-arcs -ftest-coverage -g -I. \
		-o cmpunittest cmp.o test/test.c test/tests.c test/buf.c test/utils.c \
		-lcmocka

cmpnofloattest: cmp.o
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(NOFPUTESTCFLAGS) $(LDFLAGS) \
		-fprofile-arcs -ftest-coverage -g -I. \
		-o cmpnofloattest cmp.o test/test.c test/tests.c test/buf.c \
		test/utils.c \
		-lcmocka

clangcmp.o: cmp.c
	$(CLANG) $(CFLAGS) $(EXTRA_CFLAGS) $(CMPCFLAGS) \
		-fprofile-arcs -ftest-coverage -g -I. -c cmp.c -o clangcmp.o

cmpaddrtest: clangcmp.o clean
	$(CLANG) $(CFLAGS) $(EXTRA_CFLAGS) $(TESTCFLAGS) $(ADDRCFLAGS) $(LDFLAGS) \
		-I. -o cmpaddrtest \
		cmp.c test/test.c test/tests.c test/buf.c test/utils.c \
		-lcmocka

cmpmemtest: clangcmp.o clean
	$(CLANG) $(CFLAGS) $(EXTRA_CFLAGS) $(TESTCFLAGS) $(MEMCFLAGS) $(LDFLAGS) \
		-I. -o cmpmemtest \
		cmp.c test/test.c test/tests.c test/buf.c test/utils.c \
		-lcmocka

cmpubtest: clangcmp.o clean
	$(CLANG) $(CFLAGS) $(EXTRA_CFLAGS) $(TESTCFLAGS) $(UBCFLAGS) $(LDFLAGS) \
		-I. -o cmpubtest \
		cmp.c test/test.c test/tests.c test/buf.c test/utils.c \
		-lcmocka

example1:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) --std=c89 -O3 -I. -o example1 \
		cmp.c examples/example1.c

example2:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) --std=c89 -O3 -I. -o example2 \
		cmp.c examples/example2.c

coverage:
	@rm -f base_coverage.info test_coverage.info total_coverage.info
	@rm -rf coverage
	@lcov -q -c -i -d . -o base_coverage.info
	@lcov -q -c -d . -o test_coverage.info
	@lcov -q -a base_coverage.info -a test_coverage.info -o total_coverage.info
	@lcov -q --summary total_coverage.info
	@mkdir coverage
	@genhtml -q -o coverage total_coverage.info

clean:
	@rm -f cmp.prof
	@rm -f cmpunittest
	@rm -f cmpaddrtest
	@rm -f cmpmemtest
	@rm -f cmpubtest
	@rm -f cmpnofloattest
	@rm -f cmpprof
	@rm -f example1
	@rm -f example2
	@rm -f *.o
	@rm -f *.gcno *.gcda *.info
	@rm -f cmp_data.dat

=== other/docker/compcert/Makefile ===
CC := ccomp
CFLAGS := -Wall \
	  -Wno-c11-extensions \
	  -Wno-unknown-pragmas \
	  -Wno-unused-variable \
	  -fstruct-passing -fno-unprototyped -g \
	  -Ilibsodium/src/libsodium/include \
	  $(shell pkg-config --cflags opus vpx)
LDFLAGS := -lpthread $(shell pkg-config --libs opus vpx)

libsodium_SOURCES := $(shell find libsodium/src/libsodium -name "*.c")
libsodium_OBJECTS := $(libsodium_SOURCES:.c=.o)

$(libsodium_OBJECTS): CFLAGS += \
	-DDEV_MODE \
	-DCONFIGURED \
	-D_DEFAULT_SOURCE \
	-Ilibsodium/builds/msvc \
	-Ilibsodium/src/libsodium/include/sodium

toxcore_SOURCES := $(wildcard \
	   auto_tests/auto_test_support.c \
	   auto_tests/send_message_test.c \
	   testing/misc_tools.c \
	   toxav/*.c \
	   toxcore/*.c \
	   toxcore/*/*.c \
	   toxencryptsave/*.c \
	   third_party/cmp/*.c)
toxcore_OBJECTS := $(toxcore_SOURCES:.c=.o)
$(toxcore_OBJECTS): CFLAGS += \
	-Werror \
	-D__COMPCERT__ \
	-DDISABLE_VLA \
	-DMIN_LOGGER_LEVEL=LOGGER_LEVEL_TRACE \
	-Dinline= \

send_message_test: $(libsodium_OBJECTS) $(toxcore_OBJECTS)
	$(CC) -o $@ $+ $(LDFLAGS)

=== other/docker/slimcc/Makefile ===
SOURCES		:= auto_tests/send_message_test.c \
		   auto_tests/auto_test_support.c \
		   testing/misc_tools.c \
		   $(wildcard tox*/*.c tox*/*/*.c) \
		   third_party/cmp/cmp.c
OBJECTS		:= $(SOURCES:.c=.o)

CC		:= /work/slimcc/slimcc
CFLAGS		:= $(shell pkg-config --cflags libsodium opus vpx)
LDFLAGS		:= $(shell pkg-config --libs libsodium opus vpx)

send_message_test: $(OBJECTS)
	$(CC) -o $@ $+ $(LDFLAGS)

=== other/docker/sparse/Makefile ===
SOURCES		:= $(wildcard tox*/*.c tox*/*/*.c) \
		   third_party/cmp/cmp.c
OBJECTS		:= $(SOURCES:.c=.o)

CFLAGS		:= $(shell pkg-config --cflags libsodium opus vpx)
CPPFLAGS	:= -DSPARSE -DTCP_SERVER_USE_EPOLL=1 -DMIN_LOGGER_LEVEL=LOGGER_LEVEL_TRACE

SPARSE_FLAGS	:=				\
	-Wsparse-error				\
	-Wpedantic				\
	-Waddress				\
	-Waddress-space				\
	-Wbitwise				\
	-Wbitwise-pointer			\
	-Wcast-from-as				\
	-Wcast-to-as				\
	-Wcast-truncate				\
	-Wconstant-suffix			\
	-Wconstexpr-not-const			\
	-Wcontext				\
	-Wdecl					\
	-Wdefault-bitfield-sign			\
	-Wdesignated-init			\
	-Wdo-while				\
	-Wenum-mismatch				\
	-Wexternal-function-has-definition	\
	-Wflexible-array-array			\
	-Wflexible-array-nested			\
	-Wflexible-array-union			\
	-Wimplicit-int				\
	-Winit-cstring				\
	-Wint-to-pointer-cast			\
	-Wmemcpy-max-count			\
	-Wnon-pointer-null			\
	-Wnewline-eof				\
	-Wold-initializer			\
	-Wold-style-definition			\
	-Wone-bit-signed-bitfield		\
	-Woverride-init				\
	-Woverride-init-all			\
	-Wparen-string				\
	-Wpast-deep-designator			\
	-Wpedantic				\
	-Wpointer-to-int-cast			\
	-Wptr-subtraction-blows			\
	-Wreturn-void				\
	-Wshadow				\
	-Wshift-count-negative			\
	-Wshift-count-overflow			\
	-Wsizeof-bool				\
	-Wstrict-prototypes			\
	-Wpointer-arith				\
	-Wsparse-error				\
	-Wtautological-compare			\
	-Wtransparent-union			\
	-Wtypesign				\
	-Wundef					\
	-Wuninitialized				\
	-Wunion-cast				\
	-Wvla

SMATCH_FLAGS := $(foreach i,$(shell smatch --show-checks | grep -o 'check_.*'),--enable=$i)

analyse: $(OBJECTS)

%.o: %.c
	@echo "Processing $<"
	@sparse $(CFLAGS) $(CPPFLAGS) $(SPARSE_FLAGS) $<
#	@smatch $(CFLAGS) $(CPPFLAGS) $(SMATCH_FLAGS) $<
#	@sparse-llvm $(CFLAGS) $(CPPFLAGS) $< > /dev/null

=== other/docker/esp32/main/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-field-initializers -Wno-format -DMIN_LOGGER_LEVEL=LOGGER_LEVEL_TRACE")

file(GLOB toxcore_SRCS "toxcore/*.[ch]" "toxcore/*/*.[ch]")
set(COMPONENT_SRCS
  ${toxcore_SRCS}
  other/docker/esp32/main/app_main.cc
  other/docker/esp32/main/tox_main.cc
  other/docker/esp32/main/tox_main.h
  third_party/cmp/cmp.c
  third_party/cmp/cmp.h
  toxencryptsave/defines.h)

idf_component_register(
  SRCS ${COMPONENT_SRCS}
  INCLUDE_DIRS "."
  REQUIRES esp_eth esp_netif lwip)

=== debian/changelog ===
libtoxcore (0.2.20-1build1) resolute; urgency=medium

  * Rebuild against latest libvpx

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:16:56 -0500

libtoxcore (0.2.20-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Fri, 28 Mar 2025 11:37:55 +0800

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,12 @@
  cmake,
  pkgconf,
  libconfig-dev,
- libncurses5-dev,
+ libncurses-dev,
  libopus-dev,
  libsodium-dev,
  libvpx-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@ --buildsystem=cmake

.PHONY: build
build:
	dh build --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DTEST_TIMEOUT_SECONDS=120 -DSTRICT_ABI=ON -DMUST_BUILD_TOXAV=ON

# iphy@#toktok: some of the tests use 100 ports
# And tox limits the range of ports it tries to 33445-33545 (101 ports)
#override_dh_auto_test:
#	dh_auto_test --no-parallel
# buggy - fail nearly everytime
